# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

Name:           pmd
Version:        4.2.5
Release:        %mkrel 3
Epoch:          0
Summary:        Scans Java source code and looks for potential problems
License:        BSD Style
URL:            http://pmd.sourceforge.net/
## svn export https://pmd.svn.sourceforge.net/svnroot/pmd/tags/pmd/pmd_release_4_2_1 pmd && tar cvjf pmd-src.tar.bz2 pmd
#Source0:        %{name}-src.tar.bz2
Source0:        http://downloads.sourceforge.net/pmd/pmd-src-4.2.5.zip
# This patch has not been sent upstream.  It causes the build to use installed
# jars for dependencies rather than use those distributed with the source.  It
# also kills retroweaver dead, dead, dead so it won't interfere with the build.
Patch0:         pmd-4.2.5-build.patch
# This patch was sent upstream on 11 Feb 2009.  It fixes a null pointer
# exception when using the nicerhtml output format.
Patch1:         pmd-4.2.4-nicerhtml.patch
# This patch has not been sent upstream.  It updates an ant dep in a pom file
# to use the latest groupId for ant.
Patch2:         pmd-4.2.5-antdep.patch

Group:          Development/Java
BuildRequires:  ant >= 1.6
BuildRequires:  ant-junit
BuildRequires:  java-rpmbuild
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jaxen >= 1.1.1
BuildRequires:  jpackage-utils
BuildRequires:  junit4
BuildRequires:  objectweb-asm >= 3.1
BuildRequires:  objectweb-asm-javadoc >= 3.1
BuildRequires:  unzip
BuildRequires:  xml-commons-jaxp-1.3-apis
Requires:       java >= 0:1.6.0
Requires:       jaxen >= 1.1.1
Requires:       jpackage-utils
Requires:       objectweb-asm >= 3.1
Requires:       xerces-j2
Requires:       xml-commons-jaxp-1.3-apis
BuildArch:      noarch
Requires(post):       jpackage-utils
Requires(postun):     jpackage-utils

Provides:       %{name}-manual = %{version}
Obsoletes:      %{name}-manual < 4.0.0-1

%description
PMD scans Java source code and looks for potential 
problems like:
+ Unused local variables 
+ Empty catch blocks 
+ Unused parameters 
+ Empty 'if' statements 
+ Duplicate import statements 
+ Unused private methods 
+ Classes which could be Singletons 
+ Short/long variable and method names 
PMD has plugins for JDeveloper, JEdit, JBuilder, 
NetBeans/Sun ONE Studio, IntelliJ IDEA, TextPad, 
Maven, Ant, Eclipse, Gel, and Emacs. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java

%description javadoc
Javadoc for %{name}.

%prep
%setup -q
%patch0
%patch1
%patch2

# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;

# remove an unneeded script in an otherwise documentation directory
rm -f etc/fr_docs/copy_up.sh


%build
export CLASSPATH=$(build-classpath \
                   objectweb-asm \
                   junit4 jaxen \
                  ):target/classes:target/test-classes
ant
ant -f bin/build.xml javadoc


%install
rm -rf $RPM_BUILD_ROOT
# jar
install -d -m 755 %{buildroot}%{_javadir}
install -m 644 lib/%{name}-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-%{version}.jar

(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; \
   do ln -sf ${jar} ${jar/-%{version}/}; done)

install -d -m 755 %{buildroot}%{_sysconfdir}
cp -p etc/pmd-nicerhtml.xsl %{buildroot}%{_sysconfdir}
install -d -m 755 %{buildroot}%{_datadir}/%{name}-%{version}
cp -pr etc/xslt %{buildroot}%{_datadir}/%{name}-%{version}
install -d -m 755 %{buildroot}%{_datadir}/%{name}-%{version}/rulesets
cp -pr rulesets/* %{buildroot}%{_datadir}/%{name}-%{version}/rulesets

# pom
install -d -m 755 %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}
cp -pr docs/api/* %{buildroot}%{_javadocdir}/%{name}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%config(noreplace) %{_sysconfdir}/pmd-nicerhtml.xsl
%{_javadir}/*.jar
%{_datadir}/%{name}-%{version}
%{_mavenpomdir}/*.pom
%{_mavendepmapfragdir}/*
%doc LICENSE.txt etc/changelog.txt etc/fr_docs etc/readme.txt
%doc etc/pmdProperties.rtf

%pre javadoc
[ $1 -gt 1 ] && [ -L %{_javadocdir}/%{name} ] && \
rm -rf $(readlink -f %{_javadocdir}/%{name}) %{_javadocdir}/%{name} || :

%files javadoc
%{_javadocdir}/%{name}
%doc LICENSE.txt



%changelog

* Sun Jan 13 2013 umeabot <umeabot> 0:4.2.5-3.mga3
+ Revision: 377951
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Nov 28 2011 dmorgan <dmorgan> 0:4.2.5-2.mga2
+ Revision: 173969
- Add jaxen  in the classpath
- Versionnate java requires
- Fix typo
- New version
  Sync with fedora/opensuse

  + gil <gil>
    - * correct group in main package
      * used new mvn macro
      * added %%pre script for unversioned javadoc symlink

* Mon Jan 17 2011 dmorgan <dmorgan> 0:4.2.1-2.0.5.mga1
+ Revision: 21736
- imported package pmd

